- Qt 5.15
- Qt 3D
- C++ Classes
- QAxisAccumulator
- Qt 5.15.11 Reference Documentation

# QAxisAccumulator Class

class Qt3DInput::QAxisAccumulator

QAxisAccumulator processes velocity or acceleration data from a QAxis. More...

Header: | #include <QAxisAccumulator>
qmake: | QT += 3dinput
Since: | Qt 5.8
Instantiated By: | AxisAccumulator
Inherits: | Qt3DCore::QComponent

This class was introduced in Qt 5.8.

- List of all members, including inherited members

## Public Types

enum | SourceAxisType { Velocity, Acceleration }

## Properties

- value : const float

## Public Functions

| QAxisAccumulator(Qt3DCore::QNode *parent = nullptr)
float | scale() const
Qt3DInput::QAxis * | sourceAxis() const
SourceAxisType | sourceAxisType() const
float | value() const
float | velocity() const

## Public Slots

void | setScale(float scale)
void | setSourceAxis(Qt3DInput::QAxis *sourceAxis)
void | setSourceAxisType(QAxisAccumulator::SourceAxisType sourceAxisType)

## Signals

void | scaleChanged(float scale)
void | sourceAxisChanged(Qt3DInput::QAxis *sourceAxis)
void | sourceAxisTypeChanged(QAxisAccumulator::SourceAxisType sourceAxisType)
void | valueChanged(float value)
void | velocityChanged(float value)

## Detailed Description

Constructs a new QAxisAccumulator instance with parent.

A Qt3DInput::QAxis reports the current position of an axis on an input device. When the axis is returned to its neutral position the value of that axis returns to 0. Often, it is required to have the input from an axis control a variable in other ways, for example treating the value from the Qt3DInput::QAxis as a velocity (first derivative with respect to time) or as an acceleration (second derivative with respect to time). This can be done with user code or with a Qt3DLogic::QFrameAction but those approached are not ideal as they add more work to the main thread and are inherently imperative. The Qt3DInput::QAxisAccumulator class allows for this common task to be performed on the Qt 3D backend and be specified in a declarative manner.

## Member Type Documentation

### enum QAxisAccumulator::SourceAxisType

Constant | Value
--- | ---
`Qt3DInput::QAxisAccumulator::Velocity` | `0`
`Qt3DInput::QAxisAccumulator::Acceleration` | `1`

## Property Documentation

### value : const float

Returns the accumulated (integrated) value.

Access functions:

float | value() const

Notifier signal:

void | valueChanged(float value)

## Member Function Documentation

### QAxisAccumulator::QAxisAccumulator(Qt3DCore::QNode *parent = nullptr)

Constructs a new QAxisAccumulator instance with parent parent.

### `[slot]` void QAxisAccumulator::setSourceAxis(Qt3DInput::QAxis *sourceAxis)

Sets the source axis from which the accumulator should receive values from to sourceAxis. How these values are treated is controlled by the sourceAxisType and scale properties.

Note: Setter function for property sourceAxis.

See also sourceAxis().

### `[slot]` void QAxisAccumulator::setSourceAxisType(QAxisAccumulator::SourceAxisType sourceAxisType)

Sets how the accumulator treats the values originating from the sourceAxisType.

Note: Setter function for property sourceAxisType.

See also sourceAxisType().

### float QAxisAccumulator::scale() const

The amount to scale the axis value by when accumulating. This can be thought of as the maximum velocity or acceleration the axis can control.

Returns the amount the input axis values are scaled by.

Note: Getter function for property scale.

See also setScale().

### Qt3DInput::QAxis *QAxisAccumulator::sourceAxis() const

Returns QAxis for which the accumulator should integrate axis values.

Note: Getter function for property sourceAxis.

See also setSourceAxis().

### SourceAxisType QAxisAccumulator::sourceAxisType() const

Returns how the accumulator treats the value of the sourceAxis.

Note: Getter function for property sourceAxisType.

See also setSourceAxisType().

### float QAxisAccumulator::velocity() const

Returns the velocity. If the sourceAxisType is set to Velocity this is simply the value of the source axis multiplied by the scale. If the sourceAxisType is set to Acceleration, the velocity is integrated using the source axis' value as an acceleration.

Note: Getter function for property velocity.